<?php
 
 
 

namespace Google\Protobuf;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;






class Method extends \Google\Protobuf\Internal\Message
{
    




    protected $name = '';
    




    protected $request_type_url = '';
    




    protected $request_streaming = false;
    




    protected $response_type_url = '';
    




    protected $response_streaming = false;
    




    private $options;
    




    protected $syntax = 0;

    





















    public function __construct($data = NULL) {
        \GPBMetadata\Google\Protobuf\Api::initOnce();
        parent::__construct($data);
    }

    





    public function getName()
    {
        return $this->name;
    }

    






    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    





    public function getRequestTypeUrl()
    {
        return $this->request_type_url;
    }

    






    public function setRequestTypeUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->request_type_url = $var;

        return $this;
    }

    





    public function getRequestStreaming()
    {
        return $this->request_streaming;
    }

    






    public function setRequestStreaming($var)
    {
        GPBUtil::checkBool($var);
        $this->request_streaming = $var;

        return $this;
    }

    





    public function getResponseTypeUrl()
    {
        return $this->response_type_url;
    }

    






    public function setResponseTypeUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->response_type_url = $var;

        return $this;
    }

    





    public function getResponseStreaming()
    {
        return $this->response_streaming;
    }

    






    public function setResponseStreaming($var)
    {
        GPBUtil::checkBool($var);
        $this->response_streaming = $var;

        return $this;
    }

    





    public function getOptions()
    {
        return $this->options;
    }

    






    public function setOptions($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Protobuf\Option::class);
        $this->options = $arr;

        return $this;
    }

    





    public function getSyntax()
    {
        return $this->syntax;
    }

    






    public function setSyntax($var)
    {
        GPBUtil::checkEnum($var, \Google\Protobuf\Syntax::class);
        $this->syntax = $var;

        return $this;
    }

}

